type op = And | Or | Equal | Neq | Less| Greater| Leq | Geq
type op2 = Plus | Minus | Times | Divide 
type op3 = Sin | Cos| Tan| Arcs | Arcc| Arct |Sqrt

type argument ={
		atp: string;
		vid: string;
		tid: string;
}

type parameter = {
	ptp : string;
	pname : string;
}

type nexpr =
	Num of float
	| Bool of string
	| Val of string
	| Tri_ele of string * int
	| Binop2 of nexpr * op2 * nexpr
	| Monop of op3 * nexpr



type expr =
	Binop of expr * op * expr
	| Nexpr of nexpr
	| Rev of expr

type oexpr = 
	Expr of expr
|   Rulec of string * parameter list
	

type operation =
	Block of operation list
	| If of expr * operation
	| While of expr * operation
	| Prints of string
	| Printv of expr
	| Assign of string * oexpr

type lines = {
	alen : float;
	blen : float;
	clen : float; }

type vertexes = {
	avtxx : float;
	avtxy : float;
	bvtxx : float;
	bvtxy : float;
	cvtxx : float; 
	cvtxy : float; }

type tri_decl = {
	tname : string;
	tline : lines;
	tvertex : vertexes;}


type v_decl = {
	vname: string;
	value: float;
}



type rule_decl = {
	rname : string;
	paras : parameter list;
	cond : expr;
	body :	nexpr;
}

type decl = v_decl list * tri_decl list

type program = decl * rule_decl list *operation list

